# Radian

The **radian** (symbol **rad**) is the unit for measuring angles, and is the 
standard unit of angular measure used in many areas of mathematics.

The length of an arc of a unit circle is numerically equal to the measurement 
in radians of the angle that it subtends; one radian is just under `57.3` degrees.

An arc of a circle with the same length as the radius of that circle subtends an 
angle of `1 radian`. The circumference subtends an angle of `2π radians`.

![Radian](https://upload.wikimedia.org/wikipedia/commons/4/4e/Circle_radians.gif)

A complete revolution is 2π radians (shown here with a circle of radius one and 
thus circumference `2π`).

![2 pi Radian](https://upload.wikimedia.org/wikipedia/commons/6/67/2pi-unrolled.gif)

**Conversions**

| Radians | Degrees |
| :-----: | :-----: |
| 0       | 0°      |
| π/12    | 15°     |
| π/6     | 30°     |
| π/4     | 45°     |
| 1       | 57.3°   |
| π/3     | 60°     |
| π/2     | 90°     |
| π       | 180°    |
| 2π      | 360°    |


## References

- [Wikipedia](https://en.wikipedia.org/wiki/Radian)
